import Vue from 'vue'
import Router from 'vue-router'
import { normalizeURL, decode } from 'ufo'
import { interopDefault } from './utils'
import scrollBehavior from './router.scrollBehavior.js'

const _9573e58a = () => interopDefault(import('../pages/category-creator.vue' /* webpackChunkName: "pages/category-creator" */))
const _3779027e = () => interopDefault(import('../pages/index2.vue' /* webpackChunkName: "pages/index2" */))
const _34f5c2ec = () => interopDefault(import('../pages/inspire.vue' /* webpackChunkName: "pages/inspire" */))
const _7f539c4d = () => interopDefault(import('../pages/library.vue' /* webpackChunkName: "pages/library" */))
const _5010f71a = () => interopDefault(import('../pages/market.vue' /* webpackChunkName: "pages/market" */))
const _4078c685 = () => interopDefault(import('../pages/user-profile.vue' /* webpackChunkName: "pages/user-profile" */))
const _8cd28050 = () => interopDefault(import('../pages/book/new.vue' /* webpackChunkName: "pages/book/new" */))
const _b43e2a1c = () => interopDefault(import('../pages/book/_id.vue' /* webpackChunkName: "pages/book/_id" */))
const _3e7dd938 = () => interopDefault(import('../pages/index.vue' /* webpackChunkName: "pages/index" */))

const emptyFn = () => {}

Vue.use(Router)

export const routerOptions = {
  mode: 'history',
  base: '/',
  linkActiveClass: 'nuxt-link-active',
  linkExactActiveClass: 'nuxt-link-exact-active',
  scrollBehavior,

  routes: [{
    path: "/category-creator",
    component: _9573e58a,
    name: "category-creator"
  }, {
    path: "/index2",
    component: _3779027e,
    name: "index2"
  }, {
    path: "/inspire",
    component: _34f5c2ec,
    name: "inspire"
  }, {
    path: "/library",
    component: _7f539c4d,
    name: "library"
  }, {
    path: "/market",
    component: _5010f71a,
    name: "market"
  }, {
    path: "/user-profile",
    component: _4078c685,
    name: "user-profile"
  }, {
    path: "/book/new",
    component: _8cd28050,
    name: "book-new"
  }, {
    path: "/book/:id?",
    component: _b43e2a1c,
    name: "book-id"
  }, {
    path: "/",
    component: _3e7dd938,
    name: "index"
  }],

  fallback: false
}

export function createRouter (ssrContext, config) {
  const base = (config._app && config._app.basePath) || routerOptions.base
  const router = new Router({ ...routerOptions, base  })

  // TODO: remove in Nuxt 3
  const originalPush = router.push
  router.push = function push (location, onComplete = emptyFn, onAbort) {
    return originalPush.call(this, location, onComplete, onAbort)
  }

  const resolve = router.resolve.bind(router)
  router.resolve = (to, current, append) => {
    if (typeof to === 'string') {
      to = normalizeURL(to)
    }
    return resolve(to, current, append)
  }

  return router
}
